var textarea = $('textarea');
var tweetCounter = $('.tweet-counter');
var submitButton = $('input');
var tweetList = $('.tweets');
var firstTweet = $('.tweet').first();

var calculateRemaining = function () {
  var remaining = 140 - textarea.val().length;

  tweetCounter.text(remaining);

  tweetCounter.toggleClass('warning', remaining < 16 && remaining > -1);

  tweetCounter.toggleClass('error', remaining < 0);

  /* if (remaining < 16) {
    tweetCounter.addClass('warning');
  } else {
    tweetCounter.removeClass('warning');
  } */

  submitButton.prop('disabled', remaining < 0 || remaining === 140);
};

calculateRemaining();

textarea.on('keyup', calculateRemaining);

var addNewTweet = function (response) {
  var newTweet = firstTweet.clone();

  newTweet.find('.tweet-content').text(response.tweet_content);
  newTweet.find('.avatar img').prop('src', response.tweet_avatar);
  newTweet.find('.author').text(response.tweet_author);

  newTweet.removeClass('favorited retweeted');

  tweetList.prepend(newTweet);
  // newTweet.prependTo(tweetList);
}

$('form').on('submit', function (event) {
  event.preventDefault();

  $.ajax({
    url: 'http://jeffreyatw.nfshost.com/tweet.php',
    method: 'POST',
    data: $(this).serialize()
  }).done(function (response) {
    addNewTweet(response);

    textarea.val('');

    calculateRemaining();
  }).fail(function (response) {
    console.log('oh no');
  });
});

$('.tweets').on('click', 'button', function () {
  var $this = $(this);
  var classToAdd;
  if ($this.hasClass('favorite')) {
    classToAdd = 'favorited';
  } else if ($this.hasClass('retweet')) {
    classToAdd = 'retweeted';
  }
  $this.closest('.tweet').toggleClass(classToAdd);
});

setInterval(function () {
  $.ajax({
    url: 'http://jeffreyatw.nfshost.com/tweet.php'
  }).done(addNewTweet);
}, 5000);